' TEMPLATE

' NOTE: This file is generated automatically. Do not make modifications
' outside the designated areas; if you do, your changes may be lost.


' private helper class
class CatchModeChange extends DataEventHandler
  myVehicle as Vehicle

  sub handle(name as string, data as EventData)
    call myVehicle.setWireColor(data.getInt())
  end sub 'handle
end class 'CatchModeChange

  ' *** place user const declarations here ***
  ' *** end of user const declarations ***

class Rocket_Runner extends Vehicle
    sys as VehicleSystemObject
    
    Sonar1 as Sonar
    RocketLauncher1 as RocketLauncher
    RocketLauncher2 as RocketLauncher
    HealthSensor1 as HealthSensor
    MediumRadar1 as MediumRadar
    HealthPack3 as HealthPack
    Steering1 as Steering
    MediumEngine1 as MediumEngine
    HealthPack1 as HealthPack
    HealthPack2 as HealthPack
    Compare1 as Compare
    Compare2 as Compare
    ModeSwitch1 as ModeSwitch
    Filter1 as Filter
    Filter2 as Filter
    Multiply1 as Multiply
    Divide1 as Divide
    Variable1 as Variable
    Variable2 as Variable
    TickTimer1 as TickTimer
    Timer1 as Timer
    Filter3 as Filter
    HealthManager1 as HealthManager
    Filter4 as Filter
    RangeTest1 as RangeTest
    RangeTest2 as RangeTest
    Variable3 as Variable
    Timer2 as Timer
    Sweeper1 as Sweeper

  ' *** place vehicle data and subs here ***
  ' *** end of vehicle data and subs ***

    public function getGroup() as string
        getGroup = "Battle"
    end function 'getGroup

    public function getVer() as float
        getVer = 1.01
    end function 'getVer

    public sub Sweeper1_Change_wires()
        ' wire Wire45 is a copy wire
        call MediumRadar1.setAngle(Sweeper1.Angle)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sweeper1_Change_wires

    public sub RangeTest2_InRange_wires()
        ' wire Wire44 is sendto wire
        call Steering1.setAngle(20)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'RangeTest2_InRange_wires

    public sub Timer2_Tick_wires()
        ' wire Wire42 is sendto wire
        call MediumEngine1.setThrottle(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Timer2_Tick_wires

    public sub RangeTest1_InRange_wires()
        ' wire Wire40 is sendto wire
        call MediumEngine1.setThrottle(-20)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire41 is sendto wire
        call Timer2.setTickTime(1.2)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'RangeTest1_InRange_wires

    public sub Variable3_Querying_wires()
        ' wire Wire39 is a copy wire
        call RangeTest1.setInput(Variable3.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire43 is a copy wire
        call RangeTest2.setInput(Variable3.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable3_Querying_wires

    public sub Filter4_TurnOn_wires()
        ' wire Wire38 is sendto wire
        call Variable3.Query()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter4_TurnOn_wires

    public sub MediumRadar1_TurnOn_wires()
        ' wire Wire37 is a copy wire
        call Variable3.setInput(MediumRadar1.Angle)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'MediumRadar1_TurnOn_wires

    public sub MediumRadar1_PlugIn_wires()
        ' wire Wire36 is a copy wire
        call Filter4.setFilterSocket(MediumRadar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'MediumRadar1_PlugIn_wires

    public sub HealthManager1_UseHP3_wires()
        ' wire Wire34 is sendto wire
        call HealthPack3.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthManager1_UseHP3_wires

    public sub HealthManager1_UseHP2_wires()
        ' wire Wire33 is sendto wire
        call HealthPack2.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthManager1_UseHP2_wires

    public sub HealthManager1_UseHP1_wires()
        ' wire Wire32 is sendto wire
        call HealthPack1.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthManager1_UseHP1_wires

    public sub HealthSensor1_Change_wires()
        ' wire Wire31 is a copy wire
        call HealthManager1.setHealth(HealthSensor1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'HealthSensor1_Change_wires

    public sub Filter2_TurnOn_wires()
        select case mWireColor
        case 1
            ' wire Wire7 is sendto wire
            call Steering1.setAngle(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Filter2_TurnOn_wires

    public sub Sonar1_NoPing_wires()
        select case mWireColor
        case 1
            ' wire Wire5 is sendto wire
            call Steering1.setAngle(-2)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Sonar1_NoPing_wires

    public sub Divide1_Change_wires()
        select case mWireColor
        case 1
            ' wire Wire4 is a copy wire
            call Steering1.setAngle(Divide1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Divide1_Change_wires

    public sub Filter3_TurnOff_wires()
        select case mWireColor
        case 1
            ' wire Wire30 is sendto wire
            call MediumEngine1.setThrottle(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Filter3_TurnOff_wires

    public sub Filter3_TurnOn_wires()
        select case mWireColor
        case 1
            ' wire Wire29 is sendto wire
            call MediumEngine1.setThrottle(-50)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Filter3_TurnOn_wires

    public sub Timer1_Tick_wires()
        ' wire Wire27 is sendto wire
        call RocketLauncher2.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Timer1_Tick_wires

    public sub TickTimer1_Tick_wires()
        ' wire Wire23 is sendto wire
        call Sonar1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire24 is sendto wire
        call Variable1.setIncrementBy(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'TickTimer1_Tick_wires

    public sub Compare2_GreaterThan_wires()
        ' wire Wire22 is sendto wire
        call RocketLauncher1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire26 is sendto wire
        call Timer1.setTickTime(0.1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare2_GreaterThan_wires

    public sub Compare2_EqualTo_wires()
        ' wire Wire21 is sendto wire
        call RocketLauncher1.Fire()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire25 is sendto wire
        call Timer1.setTickTime(0.1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare2_EqualTo_wires

    public sub Variable2_Querying_wires()
        ' wire Wire20 is a copy wire
        call Compare2.setInput1(Variable2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable2_Querying_wires

    public sub Filter1_TurnOn_wires()
        ' wire Wire19 is sendto wire
        call Variable2.Query()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Filter1_TurnOn_wires

    public sub ModeSwitch1_Change_wires()
        ' wire Wire15 is sendto wire
        call Variable1.setInput(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'ModeSwitch1_Change_wires

    public sub Variable1_Change_wires()
        ' wire Wire14 is a copy wire
        call Compare1.setInput1(Variable1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Variable1_Change_wires

    public sub Compare1_EqualTo_wires()
        ' wire Wire13 is sendto wire
        call ModeSwitch1.setMode(2)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare1_EqualTo_wires

    public sub Compare1_GreaterThan_wires()
        ' wire Wire12 is sendto wire
        call ModeSwitch1.setMode(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare1_GreaterThan_wires

    public sub ModeSwitch1_Set_wires()
        select case mWireColor
        case 1
            ' wire Wire9 is sendto wire
            call Sonar1.setMaxRange(5.3)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

            ' wire Wire17 is sendto wire
            call Filter1.setEnemyVehicle(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

            ' wire Wire8 is sendto wire
            call Sonar1.setAngle(-3)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        case 2
            ' wire Wire16 is sendto wire
            call Filter1.setEnemyVehicle(1)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

            ' wire Wire11 is sendto wire
            call Sonar1.setMaxRange(15)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

            ' wire Wire10 is sendto wire
            call Sonar1.setAngle(90)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'ModeSwitch1_Set_wires

    public sub Sonar1_PlugIn_wires()
        select case mWireColor
        case 1
            ' wire Wire28 is a copy wire
            call Filter3.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

            ' wire Wire6 is a copy wire
            call Filter2.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
        ' wire Wire35 is a copy wire
        call Filter1.setFilterSocket(Sonar1.FilterPlug)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sonar1_PlugIn_wires

    public sub Multiply1_Change_wires()
        select case mWireColor
        case 1
            ' wire Wire3 is a copy wire
            call Divide1.setInput2(Multiply1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
    end sub 'Multiply1_Change_wires

    public sub Sonar1_Ping_wires()
        select case mWireColor
        case 1
            ' wire Wire2 is a copy wire
            call Multiply1.setInput2(Sonar1.Distance)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

            ' wire Wire1 is a copy wire
            call Multiply1.setInput1(Sonar1.Distance)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        end select
        ' wire Wire18 is a copy wire
        call Variable2.setInput(Sonar1.Distance)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Sonar1_Ping_wires

    public function getChassisName() as string
        getChassisName = "WheelM"
    end function

    public function getDescription() as string
        getDescription = "Designed by Corvos.|"
    end function

    public function specifyComponents() as string
        specifyComponents = "WheelM Sonar RocketLauncher RocketLauncher HealthSensor MediumRadar HealthPack Steering MediumEngine HealthPack HealthPack Compare Compare ModeSwitch Filter Filter Multiply Divide Variable Variable Ti"
        specifyComponents = specifyComponents & "ckTimer Timer Filter HealthManager Filter RangeTest RangeTest Variable Timer Sweeper"
    end function
  
    function loadComponents(vehicleID as integer) as boolean
        loadComponents = false
        if not super.loadComponents(vehicleID) then
           exit function
        end if

        compRegistry as VehicleComponents
        compRegistry = sys.getNamedData("VehicleComponents", "VehicleComponents", mSelf)
        if compRegistry <> null then
           call compRegistry.setVehicleName("Rocket_Runner")
        end if

        modeEvent as DataEvent
        ' magic object shared with mode-switch component(s)
        modeEvent = sys.getNamedData("DataEvent", "ModeChange", mSelf)
        if modeEvent = null then
           call sys.printToLog("Vehicle Rocket_Runner can't get ModeChange event!")
        else
           modeCatcher as CatchModeChange
           modeCatcher = new CatchModeChange        ' get handler
           modeCatcher.myVehicle = this             ' bind myself
           call modeEvent.register(modeCatcher)     ' then register handler
        end if

        ' initialize Sonar1
        Sonar1 = sys.getComponent("Sonar")
        if Sonar1 = null then
           call sys.printToLog("Rocket_Runner: Sonar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sonar1, "Sonar", "Sonar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Sonar1, 0.0106936, -0.05, 0) then
            call sys.printToLog("Rocket_Runner: Sonar1 not placed")
            exit function
        end if
        call Sonar1.setAngle(-3)
        call Sonar1.setMaxRange(5.3)

        ' initialize RocketLauncher1
        RocketLauncher1 = sys.getComponent("RocketLauncher")
        if RocketLauncher1 = null then
           call sys.printToLog("Rocket_Runner: RocketLauncher1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RocketLauncher1, "RocketLauncher", "RocketLauncher1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(RocketLauncher1, 0.0106936, 0.025, 1) then
            call sys.printToLog("Rocket_Runner: RocketLauncher1 not placed")
            exit function
        end if
        call RocketLauncher1.setRocketSpeed(1)

        ' initialize RocketLauncher2
        RocketLauncher2 = sys.getComponent("RocketLauncher")
        if RocketLauncher2 = null then
           call sys.printToLog("Rocket_Runner: RocketLauncher2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RocketLauncher2, "RocketLauncher", "RocketLauncher2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(RocketLauncher2, -0.0393064, 0.025, 1) then
            call sys.printToLog("Rocket_Runner: RocketLauncher2 not placed")
            exit function
        end if
        call RocketLauncher2.setRocketSpeed(1)

        ' initialize HealthSensor1
        HealthSensor1 = sys.getComponent("HealthSensor")
        if HealthSensor1 = null then
           call sys.printToLog("Rocket_Runner: HealthSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthSensor1, "HealthSensor", "HealthSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthSensor1, -0.0393064, -0.05, 0) then
            call sys.printToLog("Rocket_Runner: HealthSensor1 not placed")
            exit function
        end if
        call HealthSensor1.setCritical_pct(25)
        call HealthSensor1.setHealthy_pct(100)

        ' initialize MediumRadar1
        MediumRadar1 = sys.getComponent("MediumRadar")
        if MediumRadar1 = null then
           call sys.printToLog("Rocket_Runner: MediumRadar1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(MediumRadar1, "MediumRadar", "MediumRadar1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(MediumRadar1, -0.134306, 0, 0) then
            call sys.printToLog("Rocket_Runner: MediumRadar1 not placed")
            exit function
        end if
        call MediumRadar1.setMaxRange(3)
        call MediumRadar1.setAngle(0)
        call MediumRadar1.setScanWidth(25)

        ' initialize HealthPack3
        HealthPack3 = sys.getComponent("HealthPack")
        if HealthPack3 = null then
           call sys.printToLog("Rocket_Runner: HealthPack3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack3, "HealthPack", "HealthPack3")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack3, 0.1095, 0.05, 0) then
            call sys.printToLog("Rocket_Runner: HealthPack3 not placed")
            exit function
        end if

        ' initialize Steering1
        Steering1 = sys.getComponent("Steering")
        if Steering1 = null then
           call sys.printToLog("Rocket_Runner: Steering1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Steering1, "Steering", "Steering1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Steering1, 0.1095, -0.05, 0) then
            call sys.printToLog("Rocket_Runner: Steering1 not placed")
            exit function
        end if
        call Steering1.setAngle(0)

        ' initialize MediumEngine1
        MediumEngine1 = sys.getComponent("MediumEngine")
        if MediumEngine1 = null then
           call sys.printToLog("Rocket_Runner: MediumEngine1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(MediumEngine1, "MediumEngine", "MediumEngine1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(MediumEngine1, -0.0143064, -0.1, 0) then
            call sys.printToLog("Rocket_Runner: MediumEngine1 not placed")
            exit function
        end if
        call MediumEngine1.setThrottle(100)

        ' initialize HealthPack1
        HealthPack1 = sys.getComponent("HealthPack")
        if HealthPack1 = null then
           call sys.printToLog("Rocket_Runner: HealthPack1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack1, "HealthPack", "HealthPack1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack1, 0.0106936, 0.1, 0) then
            call sys.printToLog("Rocket_Runner: HealthPack1 not placed")
            exit function
        end if

        ' initialize HealthPack2
        HealthPack2 = sys.getComponent("HealthPack")
        if HealthPack2 = null then
           call sys.printToLog("Rocket_Runner: HealthPack2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthPack2, "HealthPack", "HealthPack2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(HealthPack2, -0.0393064, 0.1, 0) then
            call sys.printToLog("Rocket_Runner: HealthPack2 not placed")
            exit function
        end if

        ' initialize Compare1
        Compare1 = sys.getComponent("Compare")
        if Compare1 = null then
           call sys.printToLog("Rocket_Runner: Compare1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Compare1, "Compare", "Compare1")
        end if
        ' Logical component doesn't need to be positioned
        call Compare1.setInput1(0)
        call Compare1.setInput2(1)
        call Compare1.setCalc(1)

        ' initialize Compare2
        Compare2 = sys.getComponent("Compare")
        if Compare2 = null then
           call sys.printToLog("Rocket_Runner: Compare2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Compare2, "Compare", "Compare2")
        end if
        ' Logical component doesn't need to be positioned
        call Compare2.setInput1(0)
        call Compare2.setInput2(0.4)
        call Compare2.setCalc(1)

        ' initialize ModeSwitch1
        ModeSwitch1 = sys.getComponent("ModeSwitch")
        if ModeSwitch1 = null then
           call sys.printToLog("Rocket_Runner: ModeSwitch1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(ModeSwitch1, "ModeSwitch", "ModeSwitch1")
        end if
        ' Logical component doesn't need to be positioned
        call ModeSwitch1.setMode(0)

        ' initialize Filter1
        Filter1 = sys.getComponent("Filter")
        if Filter1 = null then
           call sys.printToLog("Rocket_Runner: Filter1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter1, "Filter", "Filter1")
        end if
        ' Logical component doesn't need to be positioned
        call Filter1.setEnemyVehicle(0)
        call Filter1.setFilterSocket("")
        call Filter1.setOther(0)
        call Filter1.setProjectile(0)
        call Filter1.setTeammate(0)

        ' initialize Filter2
        Filter2 = sys.getComponent("Filter")
        if Filter2 = null then
           call sys.printToLog("Rocket_Runner: Filter2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter2, "Filter", "Filter2")
        end if
        ' Logical component doesn't need to be positioned
        call Filter2.setEnemyVehicle(1)
        call Filter2.setFilterSocket("")
        call Filter2.setOther(0)
        call Filter2.setProjectile(0)
        call Filter2.setTeammate(0)

        ' initialize Multiply1
        Multiply1 = sys.getComponent("Multiply")
        if Multiply1 = null then
           call sys.printToLog("Rocket_Runner: Multiply1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Multiply1, "Multiply", "Multiply1")
        end if
        ' Logical component doesn't need to be positioned
        call Multiply1.setInput1(0)
        call Multiply1.setInput2(0)

        ' initialize Divide1
        Divide1 = sys.getComponent("Divide")
        if Divide1 = null then
           call sys.printToLog("Rocket_Runner: Divide1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Divide1, "Divide", "Divide1")
        end if
        ' Logical component doesn't need to be positioned
        call Divide1.setInput1(18)
        call Divide1.setInput2(18)
        call Divide1.setCalc(1)

        ' initialize Variable1
        Variable1 = sys.getComponent("Variable")
        if Variable1 = null then
           call sys.printToLog("Rocket_Runner: Variable1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable1, "Variable", "Variable1")
        end if
        ' Logical component doesn't need to be positioned
        call Variable1.setInput(0)

        ' initialize Variable2
        Variable2 = sys.getComponent("Variable")
        if Variable2 = null then
           call sys.printToLog("Rocket_Runner: Variable2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable2, "Variable", "Variable2")
        end if
        ' Logical component doesn't need to be positioned
        call Variable2.setInput(0)

        ' initialize TickTimer1
        TickTimer1 = sys.getComponent("TickTimer")
        if TickTimer1 = null then
           call sys.printToLog("Rocket_Runner: TickTimer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(TickTimer1, "TickTimer", "TickTimer1")
        end if
        ' Logical component doesn't need to be positioned
        call TickTimer1.setRate(1)

        ' initialize Timer1
        Timer1 = sys.getComponent("Timer")
        if Timer1 = null then
           call sys.printToLog("Rocket_Runner: Timer1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Timer1, "Timer", "Timer1")
        end if
        ' Logical component doesn't need to be positioned
        call Timer1.setTickTime(0)

        ' initialize Filter3
        Filter3 = sys.getComponent("Filter")
        if Filter3 = null then
           call sys.printToLog("Rocket_Runner: Filter3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter3, "Filter", "Filter3")
        end if
        ' Logical component doesn't need to be positioned
        call Filter3.setEnemyVehicle(0)
        call Filter3.setFilterSocket("")
        call Filter3.setOther(0)
        call Filter3.setProjectile(1)
        call Filter3.setTeammate(0)

        ' initialize HealthManager1
        HealthManager1 = sys.getComponent("HealthManager")
        if HealthManager1 = null then
           call sys.printToLog("Rocket_Runner: HealthManager1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(HealthManager1, "HealthManager", "HealthManager1")
        end if
        ' Logical component doesn't need to be positioned
        call HealthManager1.setHealth(100)

        ' initialize Filter4
        Filter4 = sys.getComponent("Filter")
        if Filter4 = null then
           call sys.printToLog("Rocket_Runner: Filter4 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Filter4, "Filter", "Filter4")
        end if
        ' Logical component doesn't need to be positioned
        call Filter4.setEnemyVehicle(0)
        call Filter4.setFilterSocket("")
        call Filter4.setOther(0)
        call Filter4.setProjectile(1)
        call Filter4.setTeammate(0)

        ' initialize RangeTest1
        RangeTest1 = sys.getComponent("RangeTest")
        if RangeTest1 = null then
           call sys.printToLog("Rocket_Runner: RangeTest1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RangeTest1, "RangeTest", "RangeTest1")
        end if
        ' Logical component doesn't need to be positioned
        call RangeTest1.setMaximum(-5)
        call RangeTest1.setMinimum(-25)
        call RangeTest1.setInput(0)

        ' initialize RangeTest2
        RangeTest2 = sys.getComponent("RangeTest")
        if RangeTest2 = null then
           call sys.printToLog("Rocket_Runner: RangeTest2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(RangeTest2, "RangeTest", "RangeTest2")
        end if
        ' Logical component doesn't need to be positioned
        call RangeTest2.setMaximum(25)
        call RangeTest2.setMinimum(5)
        call RangeTest2.setInput(0)

        ' initialize Variable3
        Variable3 = sys.getComponent("Variable")
        if Variable3 = null then
           call sys.printToLog("Rocket_Runner: Variable3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Variable3, "Variable", "Variable3")
        end if
        ' Logical component doesn't need to be positioned
        call Variable3.setInput(0)

        ' initialize Timer2
        Timer2 = sys.getComponent("Timer")
        if Timer2 = null then
           call sys.printToLog("Rocket_Runner: Timer2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Timer2, "Timer", "Timer2")
        end if
        ' Logical component doesn't need to be positioned
        call Timer2.setTickTime(0)

        ' initialize Sweeper1
        Sweeper1 = sys.getComponent("Sweeper")
        if Sweeper1 = null then
           call sys.printToLog("Rocket_Runner: Sweeper1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Sweeper1, "Sweeper", "Sweeper1")
        end if
        ' Logical component doesn't need to be positioned
        call Sweeper1.setminAngle(-25)
        call Sweeper1.setmaxAngle(25)
        call Sweeper1.setIncrement(25)
        call Sweeper1.settickTime(0.1)
        call Sweeper1.setAngle(0)

        call Sweeper1.Change.register(Sweeper1_Change_wires)
        call RangeTest2.InRange.register(RangeTest2_InRange_wires)
        call Timer2.Tick.register(Timer2_Tick_wires)
        call RangeTest1.InRange.register(RangeTest1_InRange_wires)
        call Variable3.Querying.register(Variable3_Querying_wires)
        call Filter4.TurnOn.register(Filter4_TurnOn_wires)
        call MediumRadar1.TurnOn.register(MediumRadar1_TurnOn_wires)
        call MediumRadar1.PlugIn.register(MediumRadar1_PlugIn_wires)
        call HealthManager1.UseHP3.register(HealthManager1_UseHP3_wires)
        call HealthManager1.UseHP2.register(HealthManager1_UseHP2_wires)
        call HealthManager1.UseHP1.register(HealthManager1_UseHP1_wires)
        call HealthSensor1.Change.register(HealthSensor1_Change_wires)
        call Filter2.TurnOn.register(Filter2_TurnOn_wires)
        call Sonar1.NoPing.register(Sonar1_NoPing_wires)
        call Divide1.Change.register(Divide1_Change_wires)
        call Filter3.TurnOff.register(Filter3_TurnOff_wires)
        call Filter3.TurnOn.register(Filter3_TurnOn_wires)
        call Timer1.Tick.register(Timer1_Tick_wires)
        call TickTimer1.Tick.register(TickTimer1_Tick_wires)
        call Compare2.GreaterThan.register(Compare2_GreaterThan_wires)
        call Compare2.EqualTo.register(Compare2_EqualTo_wires)
        call Variable2.Querying.register(Variable2_Querying_wires)
        call Filter1.TurnOn.register(Filter1_TurnOn_wires)
        call ModeSwitch1.Change.register(ModeSwitch1_Change_wires)
        call Variable1.Change.register(Variable1_Change_wires)
        call Compare1.EqualTo.register(Compare1_EqualTo_wires)
        call Compare1.GreaterThan.register(Compare1_GreaterThan_wires)
        call ModeSwitch1.Set.register(ModeSwitch1_Set_wires)
        call Sonar1.PlugIn.register(Sonar1_PlugIn_wires)
        call Multiply1.Change.register(Multiply1_Change_wires)
        call Sonar1.Ping.register(Sonar1_Ping_wires)

  ' *** place user initialization here ***
  ' *** end of user initialization ***

        loadComponents = true           ' if we got this far, we succeeded
    end function 'loadComponents

    sub init(sysobj as VehicleSystemObject)
        sys = sysobj
  ' *** place user variable init here ***
  ' *** end of user variable init ***
    end sub 'init

end class 'Rocket_Runner
' END TEMPLATE
